/*

 old chair include

*/

#version unofficial megapov 0.7;

// parameters: base wood texture, random seed, test on/off)
#macro old_chair(t_base,rs,test)

#local rs1=seed(rs);
#local ch_width=16;
#local ch_depth=16;

#local seat_quilt=
blob{threshold .8
 cylinder{<-1,-0.25,-1>,<-1,-0.25, 1>,1,1}
 cylinder{<-1,-0.25, 1>,< 1,-0.25, 1>,1,1}
 cylinder{< 1,-0.25, 1>,< 1,-0.25,-1>,1,1}
 cylinder{< 1,-0.25,-1>,<-1,-0.25,-1>,1,1}
 cylinder{<0,-0.25,-1>,<0,-0.25,1>,1,1}
 cylinder{<-1,-0.25,0>,<1,-0.25,0>,1,1}
 sphere{<-1.25,-0.25,-1.25>,.5,1}
 sphere{< 1.25,-0.25,-1.25>,.5,1}
 cylinder{<-1,0.25,-1>,<-1,0.25, 1>,1,1}
 cylinder{<-1,0.25, 1>,< 1,0.25, 1>,1,1}
 cylinder{< 1,0.25, 1>,< 1,0.25,-1>,1,1}
 cylinder{<0,0.25,-1>,<0,0.25,1>,1,1}
 cylinder{<-1,0.25,0>,<1,0.25,0>,1,1}
 sphere{<0,1,.5>,1,-1}
 sphere{<0,1,0>,1,-1}
 scale .5
}

#local leg= 
union{
 cone{<0,0,0>,.5,<0,2,0>,1.5}
 torus{1.5,.5 translate 2.5*y}
 cylinder{<0,3,0>,<0,4,0>,1.4} 
 torus{1.5,.5 translate 4.5*y}
 superellipsoid{<.1,.1> rotate 90*x scale .5 scale <4,4,4> translate 7*y}
 torus{1.5,.5 translate 9.5*y}
 cone{<0,10,0>,1.5,<0,12,0>,.8}
 torus{1,.5 translate 12.5*y}
 cone{<0,13,0>,.8,<0,15,0>,1.5}
 torus{1.5,.5 translate 15.5*y}
 superellipsoid{<.1,.1> rotate 90*x scale .5 scale <4,4,4> translate 18*y}
 torus{1.5,.5 translate 20.5*y}
 cone{<0,21,0>,1.5,<0,23,0>,.8}
 torus{1,.5 translate 23.5*y}
 cone{<0,24,0>,.8,<0,26,0>,1.5}
 torus{1.5,.5 translate 26.5*y}
 superellipsoid{<.1,.1> rotate 90*x scale .5 scale <4,10,4> translate 32*y}
}         
#local S = function {(abs(x)-1) & (abs(y)-1) & (abs(z)-1) }
#local N = 1;
#local leg_cross=
isosurface {
 function {S(x,  -z*sin(x*2*pi*N) + y*cos(x*2*pi*N),  z*cos(x*2*pi*N) + y*sin(x*2*pi*N))}
 accuracy 0.0001
 contained_by { box {-1,1} }
}

#local legs=
union{
 object{leg 
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <-ch_width,0,-ch_depth>
 }
 object{leg 
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <-ch_width,0, ch_depth>
 }
 object{leg 
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate < ch_width,0,-ch_depth>
 }
 object{leg 
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate < ch_width,0, ch_depth>
 }
 object{leg_cross 
  scale <ch_width,1,1>
  texture{t_base rotate 90*y translate 100*rand(rs1)*x}
  translate <0,18,-ch_depth>
 }
 object{leg_cross 
  scale <ch_width,1,1>
  texture{t_base rotate 90*y translate 100*rand(rs1)*x}
  translate <0,18, ch_depth>
 }
 object{leg_cross 
  scale <ch_depth,1,1>
  rotate 90*y 
  texture{t_base translate 100*rand(rs1)*z}
  translate < ch_width,7,0>
 }
 object{leg_cross 
  scale <ch_depth,1,1>
  rotate 90*y 
  texture{t_base translate 100*rand(rs1)*z}
  translate <-ch_width,7,0>
 }
}
#local t_seat_quilt=
texture{
 pigment{HuntersGreen*.5+Gray10}
 normal{crackle turbulence .2 scale 4}
 finish{metallic phong 2 reflection .05}
}
texture{
 pigment{
  bozo
  turbulence .3
  color_map{
   [0.0 Clear]
   [0.4 DarkTan filter 0.8]
   [1.0 Clear]
  }
 }
 scale 10
}
texture{
 pigment{
  wrinkles
  turbulence .4
  color_map{
   [0.0 Clear]
   [0.2 DarkTan filter 0.8]
   [1.0 Clear]
  }
  scale 2
 }
 scale 10
}
#local reposab=
union{
 box{-1,1 scale <3,1.3,16> rotate -1.5*x translate -6*z}
 torus{1.5,.5 rotate 90*x translate 10.5*z}
 cone{<0,0,11>,.5,<0,0,13>,1.5}
 torus{1.5,.5 rotate 90*x translate 13.5*z}
 union{
  superellipsoid{<.9,.1> scale <2.9,3,3> rotate 90*y}
  torus{2.3,.7 rotate 90*z translate <2.9,0,0>}
  torus{2.3,.7 rotate 90*z translate <-2.9,0,0>}
  torus{1.4,.7 rotate 90*z translate <2.9,0,0>}
  torus{1.4,.7 rotate 90*z translate <-2.9,0,0>}
  sphere{0,1.1 translate <-2.8,0,0>}
  sphere{0,1.1 translate <2.8,0,0>}
  translate <0,-2,-21>
 }
}
#local seat=
union{
 box{-1,1 scale <ch_width,3,2>
  texture{t_base rotate 90*y translate 100*rand(rs1)*x} 
  translate <0,0,-ch_depth+0>
 }
 box{-1,1 scale <ch_width,3,2>
  texture{t_base rotate 90*y translate 100*rand(rs1)*x} 
  translate <0,0,ch_depth-0>
 }
 box{-1,1 scale <2,3,ch_depth>
  texture{t_base translate 100*rand(rs1)*z} 
  translate <-ch_width+0,0,0>
 }
 box{-1,1 scale <2,3,ch_depth>
  texture{t_base translate 100*rand(rs1)*z} 
  translate <ch_width-0,0,0>
 }
 object{seat_quilt
  scale <ch_width*1.3,10,ch_depth*1.35>
  texture{t_seat_quilt}
  translate 3*y
 }
 object{leg_cross 
  scale <12,1,1> 
  texture{t_base rotate 90*y translate 100*rand(rs1)*x}
  rotate 90*z
  translate <-ch_width,6,-ch_depth>
 }
 object{leg_cross 
  scale <12,1,1> 
  texture{t_base rotate 90*y translate 100*rand(rs1)*x}
  rotate 90*z
  translate <ch_width,6,-ch_depth>
 }
 object{reposab
  texture{t_base translate 100*rand(rs1)*z}
  rotate 1*x
  translate <-ch_width,17,4>
 } 
 object{reposab
  texture{t_base translate 100*rand(rs1)*z}
  rotate 1*x
  translate < ch_width,17,4>
 }
 union{
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <ch_width,17.5,0>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <-ch_width,17.5,0>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <ch_width,17.5,-5>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <-ch_width,17.5,-5>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <ch_width,17.5,-10>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <-ch_width,17.5,-10>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <ch_width,17.5,5>
 }
 object{seat_quilt
  scale <5,5,6>
  texture{t_seat_quilt}
  translate <-ch_width,17.5,5>
 }
  rotate 1*x
 translate 1*z
 }
}
#local back_leg=
union{
 superellipsoid{<.1,.1> rotate 90*x scale .5 scale <4,16,4> translate 8*y}
 torus{1.5,.5 translate 13.5*y}
 cone{<0,14,0>,1.5,<0,16,0>,.8}
 torus{1,.5 translate 16.5*y}
 cone{<0,17,0>,.8,<0,19,0>,1.5}
 torus{1.5,.5 translate 19.5*y}
 superellipsoid{<.1,.1> rotate 90*x scale .5 scale <4,4,4> translate 22*y}
 torus{1.5,.5 translate 24.5*y}
 object{leg_cross 
  scale <8,1,1> 
  rotate 90*z
  translate 26*y
 }
 torus{1.5,.5 translate 33.5*y}
 superellipsoid{<.1,.1> rotate 90*x scale .5 scale <3.8,16,3.8> translate 41*y}
 torus{1.5,.5 translate 49.5*y}
 cone{<0,50,0>,1.5,<0,51,0>,.8}
 sphere{0,1 translate 52*y}
}         
#local back=
union{
 box{-1,1 scale <ch_width,1,1>
  texture{t_base rotate 90*y translate 100*rand(rs1)*x} 
  translate <0,12,ch_depth>
 }
 object{back_leg 
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <-ch_width,0,ch_depth>
 }
 object{back_leg 
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate < ch_width,0,ch_depth>
 }
/* box{-1,1 scale <ch_width,7,2>
  texture{t_base rotate 90*y translate 100*rand(rs1)*x} 
  translate <0,41,ch_depth>
 }*/
 object{leg_cross
  scale <11,1,1>
  rotate 90*z
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <-5,23,ch_depth>
 }
 object{leg_cross
  scale <11,1,1>
  rotate 90*z
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <5,23,ch_depth>
 }
 object{leg_cross
  scale <11,1,1>
  rotate 90*z
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <-5,23-11,ch_depth>
 }
 object{leg_cross
  scale <11,1,1>
  rotate 90*z
  texture{t_base rotate 90*x translate 100*rand(rs1)*y}
  translate <5,23-11,ch_depth>
 }
 object{seat_quilt
  rotate 90*x
  scale <16,10,8>
  texture{t_seat_quilt}
  translate <0,41,ch_depth>
 }
}
union{
 object{legs}
 object{seat translate 34.5*y}
 object{back rotate 5*x translate 38*y}
}

#end

